<?xml version="1.0"?>
<!DOCTYPE modulesynopsis SYSTEM "../style/modulesynopsis.dtd">
<?xml-stylesheet type="text/xsl" href="../style/manual.fr.xsl"?>
<!-- English Revision : 1334011 -->
<!-- French translation : Lucien GENTIS -->
<!-- Reviewed by : Vincent Deffontaines -->

<!--
 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to You under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->

<!--<modulesynopsis> is the root tag and must surround all other tags.
The sequence of tags is important and must be followed in order for
the document to validate. -->

<modulesynopsis metafile="mod_dialup.xml.meta">
<name>mod_dialup</name>
<description>Envoie le contenu statique avec une bande passante limit&eacute;e
d&eacute;finie par les diff&eacute;rents standards des anciens modems.</description>
<status>Experimental</status>
<sourcefile>mod_dialup.c</sourcefile>
<identifier>dialup_module</identifier>

<summary>
<p>Il s'agit d'un module qui envoie le contenu statique avec une bande
passante limit&eacute;e d&eacute;finie par les diff&eacute;rents standards des anciens
modems. Ainsi, il est possible de naviguer sur votre site avec un modem
56k V.92 en positionnant une configuration de ce type :</p>

<highlight language="config">
&lt;Location /mysite&gt;
    ModemStandard V.92
&lt;/Location&gt;
</highlight>

<p>Auparavant, pour faire des modules de limitation de bande passante,
il fallait monopoliser un thread, pour chaque client, et ins&eacute;rer des
temporisations pour diminuer la bande passante. Gr&acirc;ce &agrave; cette nouvelle
fonctionnalit&eacute;, un gestionnaire peut recevoir les r&eacute;ponses &agrave; ses
callbacks apr&egrave;s N millisecondes, et il sera invoqu&eacute; par le module MPM
Event dans un thread diff&eacute;rent &agrave; la fin du d&eacute;lai indiqu&eacute;. &Agrave; partir de ce
moment, le gestionnaire peut continuer &agrave; envoyer des donn&eacute;es au
client.</p>
</summary>

<directivesynopsis>
<name>ModemStandard</name>
<description>Standard de modem &agrave; simuler</description>
<syntax>ModemStandard V.21|V.26bis|V.32|V.92</syntax>
<contextlist><context>directory</context></contextlist>

<usage>
<p>Cette directive permet de sp&eacute;cifier le standard de modem que vous
souhaitez simuler.</p>

<highlight language="config">
&lt;Location /mysite&gt;
    ModemStandard V.26bis
&lt;/Location&gt;
</highlight>

</usage>

</directivesynopsis>

</modulesynopsis>

