<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE sitemap SYSTEM "./style/sitemap.dtd">
<?xml-stylesheet type="text/xsl" href="./style/manual.fr.xsl"?>
<!-- English Revision : 1075625 -->
<!-- French translation : Lucien GENTIS -->
<!-- Reviewed by : Vincent Deffontaines -->

<!--
 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to You under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->

<sitemap metafile="sitemap.xml.meta">

  <title>Plan du site</title>

<summary>
<p>Cette page contient la liste des &eacute;l&eacute;ments actuellement disponibles de
la <a href="./">Documentation du serveur HTTP Apache Version
&httpd.major;.&httpd.minor;</a>.</p>
</summary>

<category id="release">
<title>Notes de version</title>
<page href="upgrading.html">Mise &agrave; jour vers 2.4 depuis 2.2</page>
<page href="new_features_2_4.html">Nouvelles fonctionnalit&eacute;s d'Apache 2.3/2.4</page>
<page href="new_features_2_2.html">Nouvelles fonctionnalit&eacute;s d'Apache 2.1/2.2</page>
<page href="new_features_2_0.html">Nouvelles fonctionnalit&eacute;s d'Apache 2.0</page>
<page href="license.html">License Apache</page>
</category>

<category id="using">
<title>Utilisation du serveur HTTP Apache</title>
<page href="install.html">Compilation et installation</page>
<page href="invoking.html">D&eacute;marrage</page>
<page href="stopping.html">Arr&ecirc;t ou red&eacute;marrage</page>
<page href="configuring.html">Fichiers de configuration</page>
<page href="sections.html">Comment fonctionnent les sections Directory,
Location et Files</page>
<page href="caching.html">Mise en cache du contenu</page>
<page href="server-wide.html">Configuration niveau serveur</page>
<page href="logs.html">Fichiers de traces</page>
<page href="urlmapping.html">Mise en correspondance des URLs avec le syst&egrave;me de fichiers</page>
<page href="misc/security_tips.html">Conseils sur la s&eacute;curit&eacute;</page>
<page href="dso.html">Objets Dynamiques Partag&eacute;s (DSO)</page>
<page href="content-negotiation.html">N&eacute;gociation sur le contenu</page>
<page href="custom-error.html">Messages d'erreur personnalis&eacute;s</page>
<page href="bind.html">D&eacute;finition des adresses et ports qu'utilise
Apache</page>
<page href="mpm.html">Modules multi-processus (MPMs)</page>
<page href="env.html">Les variables d'environnement d'Apache</page>
<page href="expr.html">L'interpr&eacute;tation des expressions dans Apache</page>
<page href="handler.html">Utilisation des gestionnaires d'Apache</page>
<page href="filter.html">Filtres</page>
<page href="socache.html">Support du cache des objets partag&eacute;s</page>
<page href="suexec.html">Support de suEXEC</page>
<page href="misc/perf-tuning.html">Optimisation des performances</page>
<page href="http://wiki.apache.org/httpd/FAQ">Foire aux Questions</page>
</category>

<category id="vhosts">
<title>Documentation des serveurs virtuels Apache</title>
<page separate="yes" href="vhosts/">Aper&ccedil;u</page>
<page href="vhosts/name-based.html">Serveurs virtuels bas&eacute;s sur le nom</page>
<page href="vhosts/ip-based.html">Support des serveurs virtuels bas&eacute;s
sur l'adresse IP</page>
<page href="vhosts/mass.html">Configuration dynamique de l'h&eacute;bergement
virtuel de masse</page>
<page href="vhosts/examples.html">Exemples de serveurs virtuels</page>
<page href="vhosts/details.html">Discussion approfondie &agrave; propos de la
s&eacute;lection d'un serveur virtuel</page>
<page href="vhosts/fd-limits.html">Limitations inh&eacute;rentes aux
descripteurs de fichiers</page>
<page href="dns-caveats.html">Probl&egrave;mes avec DNS et Apache</page>
</category>

<category id="rewrite">
<title>Guide de r&eacute;&eacute;criture d'URLs</title>
<page separate="yes" href="rewrite/">Aper&ccedil;u</page>
<page href="mod/mod_rewrite.html">Documentation de r&eacute;f&eacute;rence de mod_rewrite</page>
<page href="rewrite/intro.html">Introduction</page>
<page href="rewrite/flags.html">Drapeaux</page>
<page href="rewrite/tech.html">D&eacute;tails techniques</page>
<page href="rewrite/remapping.html">Remise en correspondance des URLs</page>
<page href="rewrite/access.html">Contr&ocirc;le d'acc&egrave;s</page>
<page href="rewrite/advanced.html">Guide de r&eacute;&eacute;criture avanc&eacute;e -
autres exemples utiles</page>
</category>

<category id="ssl">
<title>Chiffrement SSL/TLS avec Apache</title>
<page separate="yes" href="ssl/">Aper&ccedil;u</page>
<page href="ssl/ssl_intro.html">Chiffrement SSL/TLS :
Introduction</page>
<page href="ssl/ssl_compat.html">Chiffrement SSL/TLS :
Compatibilit&eacute;</page>
<page href="ssl/ssl_howto.html">Chiffrement SSL/TLS : Recettes</page>
<page href="ssl/ssl_faq.html">Chiffrement SSL/TLS : FAQ</page>
</category>

<category id="howto">
<title>Guides, Tutoriels, and Recettes</title>
<page separate="yes" href="howto/">Aper&ccedil;u</page>
<page href="howto/auth.html">Authentification</page>
<page href="howto/cgi.html">Contenu dynamique avec CGI</page>
<page href="howto/ssi.html">Introduction aux Inclusions c&ocirc;t&eacute; serveur
(Server Side Includes - SSI)</page>
<page href="howto/htaccess.html">Fichiers .htaccess</page>
<page href="howto/public_html.html">R&eacute;pertoires web des
utilisateurs</page>
</category>

<category id="platform">
<title>Notes sp&eacute;cifiques &agrave; certains syst&egrave;mes</title>
<page separate="yes" href="platform/">Aper&ccedil;u</page>
<page href="platform/windows.html">Utiliser Apache avec Microsoft
Windows</page>
<page href="platform/win_compiling.html">Compiler Apache pour
Microsoft Windows</page>
<page href="platform/netware.html">Utiliser Apache avec Novell
NetWare</page>
<page href="platform/perf-hp.html">Mise en oeuvre d'un serveur web
hautes performances sous HPUX</page>
<page href="platform/ebcdic.html">Le portage EBCDIC d'Apache</page>
</category>

<category id="programs">
<title>Le serveur HTTP Apache et ses programmes associ&eacute;s</title>
<page separate="yes" href="programs/">Aper&ccedil;u</page>
<page href="programs/httpd.html">Page de manuel : httpd</page>
<page href="programs/ab.html">Page de manuel : ab</page>
<page href="programs/apachectl.html">Page de manuel : apachectl</page>
<page href="programs/apxs.html">Page de manuel : apxs</page>
<page href="programs/configure.html">Page de manuel : configure</page>
<page href="programs/dbmmanage.html">Page de manuel : dbmmanage</page>
<page href="programs/htcacheclean.html">Page de manuel : htcacheclean</page>
<page href="programs/htdbm.html">Page de manuel : htdbm</page>
<page href="programs/htdigest.html">Page de manuel : htdigest</page>
<page href="programs/htpasswd.html">Page de manuel : htpasswd</page>
<page href="programs/logresolve.html">Page de manuel : logresolve</page>
<page href="programs/rotatelogs.html">Page de manuel : rotatelogs</page>
<page href="programs/suexec.html">Page de manuel : suexec</page>
<page href="programs/other.html">Autres programmes</page>
</category>

<category id="misc">
<title>Documentations diverses sur Apache</title>
<page separate="yes" href="misc/">Aper&ccedil;u</page>
<page href="misc/relevant_standards.html">Standards concern&eacute;s</page>
</category>

<category id="modules">
<title>Modules Apache</title>
<page href="mod/module-dict.html">D&eacute;finitions des termes utilis&eacute;s pour
d&eacute;crire les modules Apache</page>
<page href="mod/directive-dict.html">D&eacute;finitions des termes utilis&eacute;s
pour d&eacute;crire les directives Apache</page>
</category>

<category id="developer">
<title>Documentation du d&eacute;veloppeur</title>
<page separate="yes" href="developer/">Aper&ccedil;u</page>
<page href="developer/API.html">Notes sur l'API Apache</page>
<page href="developer/new_api_2_4.html">Mises &agrave; jour de l'API dans Apache HTTPD 2.4</page>
<page href="developer/debugging.html">D&eacute;bogage de l'allocation m&eacute;moire
dans APR</page>
<page href="developer/documenting.html">Documenter Apache 2.x</page>
<page href="developer/hooks.html">Fonctions d'accroche (Hook Functions)
d'Apache 2.x</page>
<page href="developer/modules.html">Convertir un module depuis Apache
1.3 vers Apache 2.x</page>
<page href="developer/request.html">Traitement des requ&ecirc;tes avec Apache
2.x</page>
<page href="developer/filters.html">Fonctionnement des filtres dans
Apache 2.x</page>
</category>

<category id="index">
<title>Glossaire et Index</title>
<page href="glossary.html">Glossaire</page>
<page href="mod/">Index des modules</page>
<page href="mod/directives.html">Index des directives</page>
<page href="mod/quickreference.html">R&eacute;f&eacute;rence rapide des directives</page>
</category>

</sitemap>
